// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from tuw_geometry_msgs:msg/WeightedPoseWithCovariance.idl
// generated code does not contain a copyright notice
#include "tuw_geometry_msgs/msg/detail/weighted_pose_with_covariance__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `pose`
#include "geometry_msgs/msg/detail/pose__functions.h"

bool
tuw_geometry_msgs__msg__WeightedPoseWithCovariance__init(tuw_geometry_msgs__msg__WeightedPoseWithCovariance * msg)
{
  if (!msg) {
    return false;
  }
  // pose
  if (!geometry_msgs__msg__Pose__init(&msg->pose)) {
    tuw_geometry_msgs__msg__WeightedPoseWithCovariance__fini(msg);
    return false;
  }
  // covariance
  // weight
  return true;
}

void
tuw_geometry_msgs__msg__WeightedPoseWithCovariance__fini(tuw_geometry_msgs__msg__WeightedPoseWithCovariance * msg)
{
  if (!msg) {
    return;
  }
  // pose
  geometry_msgs__msg__Pose__fini(&msg->pose);
  // covariance
  // weight
}

bool
tuw_geometry_msgs__msg__WeightedPoseWithCovariance__are_equal(const tuw_geometry_msgs__msg__WeightedPoseWithCovariance * lhs, const tuw_geometry_msgs__msg__WeightedPoseWithCovariance * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // pose
  if (!geometry_msgs__msg__Pose__are_equal(
      &(lhs->pose), &(rhs->pose)))
  {
    return false;
  }
  // covariance
  for (size_t i = 0; i < 36; ++i) {
    if (lhs->covariance[i] != rhs->covariance[i]) {
      return false;
    }
  }
  // weight
  if (lhs->weight != rhs->weight) {
    return false;
  }
  return true;
}

bool
tuw_geometry_msgs__msg__WeightedPoseWithCovariance__copy(
  const tuw_geometry_msgs__msg__WeightedPoseWithCovariance * input,
  tuw_geometry_msgs__msg__WeightedPoseWithCovariance * output)
{
  if (!input || !output) {
    return false;
  }
  // pose
  if (!geometry_msgs__msg__Pose__copy(
      &(input->pose), &(output->pose)))
  {
    return false;
  }
  // covariance
  for (size_t i = 0; i < 36; ++i) {
    output->covariance[i] = input->covariance[i];
  }
  // weight
  output->weight = input->weight;
  return true;
}

tuw_geometry_msgs__msg__WeightedPoseWithCovariance *
tuw_geometry_msgs__msg__WeightedPoseWithCovariance__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_geometry_msgs__msg__WeightedPoseWithCovariance * msg = (tuw_geometry_msgs__msg__WeightedPoseWithCovariance *)allocator.allocate(sizeof(tuw_geometry_msgs__msg__WeightedPoseWithCovariance), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(tuw_geometry_msgs__msg__WeightedPoseWithCovariance));
  bool success = tuw_geometry_msgs__msg__WeightedPoseWithCovariance__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
tuw_geometry_msgs__msg__WeightedPoseWithCovariance__destroy(tuw_geometry_msgs__msg__WeightedPoseWithCovariance * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    tuw_geometry_msgs__msg__WeightedPoseWithCovariance__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
tuw_geometry_msgs__msg__WeightedPoseWithCovariance__Sequence__init(tuw_geometry_msgs__msg__WeightedPoseWithCovariance__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_geometry_msgs__msg__WeightedPoseWithCovariance * data = NULL;

  if (size) {
    data = (tuw_geometry_msgs__msg__WeightedPoseWithCovariance *)allocator.zero_allocate(size, sizeof(tuw_geometry_msgs__msg__WeightedPoseWithCovariance), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = tuw_geometry_msgs__msg__WeightedPoseWithCovariance__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        tuw_geometry_msgs__msg__WeightedPoseWithCovariance__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
tuw_geometry_msgs__msg__WeightedPoseWithCovariance__Sequence__fini(tuw_geometry_msgs__msg__WeightedPoseWithCovariance__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      tuw_geometry_msgs__msg__WeightedPoseWithCovariance__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

tuw_geometry_msgs__msg__WeightedPoseWithCovariance__Sequence *
tuw_geometry_msgs__msg__WeightedPoseWithCovariance__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_geometry_msgs__msg__WeightedPoseWithCovariance__Sequence * array = (tuw_geometry_msgs__msg__WeightedPoseWithCovariance__Sequence *)allocator.allocate(sizeof(tuw_geometry_msgs__msg__WeightedPoseWithCovariance__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = tuw_geometry_msgs__msg__WeightedPoseWithCovariance__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
tuw_geometry_msgs__msg__WeightedPoseWithCovariance__Sequence__destroy(tuw_geometry_msgs__msg__WeightedPoseWithCovariance__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    tuw_geometry_msgs__msg__WeightedPoseWithCovariance__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
tuw_geometry_msgs__msg__WeightedPoseWithCovariance__Sequence__are_equal(const tuw_geometry_msgs__msg__WeightedPoseWithCovariance__Sequence * lhs, const tuw_geometry_msgs__msg__WeightedPoseWithCovariance__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!tuw_geometry_msgs__msg__WeightedPoseWithCovariance__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
tuw_geometry_msgs__msg__WeightedPoseWithCovariance__Sequence__copy(
  const tuw_geometry_msgs__msg__WeightedPoseWithCovariance__Sequence * input,
  tuw_geometry_msgs__msg__WeightedPoseWithCovariance__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(tuw_geometry_msgs__msg__WeightedPoseWithCovariance);
    tuw_geometry_msgs__msg__WeightedPoseWithCovariance * data =
      (tuw_geometry_msgs__msg__WeightedPoseWithCovariance *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!tuw_geometry_msgs__msg__WeightedPoseWithCovariance__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          tuw_geometry_msgs__msg__WeightedPoseWithCovariance__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!tuw_geometry_msgs__msg__WeightedPoseWithCovariance__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
